#pragma once

//#include <set>
#include <list>
class CModalDialogMgr;

//class IModalDialogClose
//{
//public:
//    IModalDialogClose(CModalDialogMgr* pModalDlgMgr);
//    virtual ~IModalDialogClose();
//private:
//    CModalDialogMgr*    m_pModalDlgMgr;
//};

//class IModalDialogMgr
//{
//public:
//    virtual void Register(IModalDialogClose* pDialog) = 0;
//    virtual void UnRegister(IModalDialogClose* pDialog) = 0;
//    virtual BOOL CloseAllModalDialog() = 0;
//};

enum MODAL_TYPE{
    mtMfcDialog,
    mtDuiWnd,
};

struct ModalWndInfo
{
    MODAL_TYPE type;
    //DWORD_PTR  param;
    union{
        CDialog* pDialog;
        CWindowWnd* pDuiModalWnd;
    };
     bool operator == (const ModalWndInfo & other);

};
class CModalDialogMgr// : public IModalDialogMgr
{
public:
    virtual ~CModalDialogMgr();
    //for MFC modal dialog -- DoModal
    void RegisterMfcModalDlg(CDialog* pDialog);
    void UnRegisterMfcModalDlg(CDialog* pDialog);

    //for DUI modal dialog -- ShowModal
    void RegisterDuiModalWnd(CWindowWnd* pDuiModalWnd);
    void UnRegisterDuiModalWnd(CWindowWnd* pDuiModalWnd);

    BOOL CloseAllModalDialog();
    INT  GetModalWndCount();
private:
    CCriticalSection    m_csLock;
    typedef std::list<ModalWndInfo>     ModalWndContainer;
    ModalWndContainer   m_allModalWnds;

    ModalWndInfo* _FindModalWnd(const ModalWndInfo& wndInfo);
    //typedef std::set<CDialog*> MFCModalDialogCloseContainer;
    //MFCModalDialogCloseContainer   m_allMfcModalDialogs;

    //typedef std::set<CWindowWnd*> DuiModalWndCloseContainer;
    //DuiModalWndCloseContainer   m_allDuiModalWnds;
};
